"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.styles = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _styles = require("@material-ui/core/styles");

var _colorManipulator = require("@material-ui/core/styles/colorManipulator");

var _Fab = _interopRequireDefault(require("@material-ui/core/Fab"));

var _Tooltip = _interopRequireDefault(require("@material-ui/core/Tooltip"));

var _Paper = _interopRequireDefault(require("@material-ui/core/Paper"));

var _Typography = _interopRequireDefault(require("@material-ui/core/Typography"));

// @inheritedComponent Tooltip
var styles = function styles(theme) {
  return {
    /* Styles applied to the root (`Tooltip`) component. */
    root: {
      position: 'relative'
    },

    /* Styles applied to the `Tooltip` label wrapper element */
    tooltip: {
      backgroundColor: theme.palette.background.paper,
      borderRadius: theme.shape.borderRadius,
      boxShadow: theme.shadows[1],
      fontSize: theme.typography.pxToRem(14),
      color: theme.palette.text.primary,
      padding: '5px 16px'
    },

    /* Styles applied to the `Button` component. */
    actionButton: {
      margin: 8,
      color: theme.palette.text.secondary,
      backgroundColor: (0, _colorManipulator.emphasize)(theme.palette.background.default, 0.12),
      '&:hover': {
        backgroundColor: (0, _colorManipulator.emphasize)(theme.palette.background.default, 0.15)
      }
    },

    /* Styles applied to the `Button` or `Paper` component if `open={true}`. */
    button: {
      transition: "".concat(theme.transitions.create('transform', {
        duration: theme.transitions.duration.shorter
      }), ", opacity 0.8s"),
      opacity: 1
    },

    /* Styles applied to the `Button` or `Paper` component if `open={false}`. */
    buttonClosed: {
      opacity: 0,
      transform: 'scale(0)'
    },

    /* Styles applied to the `Paper` component if `tooltipOpen={true}` */
    textLabel: {
      position: 'absolute',
      right: 65,
      top: 14,
      padding: '5px 16px'
    },

    /* Styles applied to the root (`span`) component if `tooltipOpen={true}`. */
    tooltipOpenContainer: {
      position: 'relative'
    }
  };
};

exports.styles = styles;

var SpeedDialAction =
/*#__PURE__*/
function (_React$Component) {
  (0, _inherits2.default)(SpeedDialAction, _React$Component);

  function SpeedDialAction(props) {
    var _this;

    (0, _classCallCheck2.default)(this, SpeedDialAction);
    _this = (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(SpeedDialAction).call(this));

    _this.handleTooltipClose = function () {
      _this.setState({
        tooltipOpen: false
      });
    };

    _this.handleTooltipOpen = function () {
      _this.setState({
        tooltipOpen: true
      });
    };

    _this.state = {
      tooltipOpen: props.tooltipOpen
    };
    return _this;
  }

  (0, _createClass2.default)(SpeedDialAction, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          ButtonProps = _this$props.ButtonProps,
          classes = _this$props.classes,
          className = _this$props.className,
          delay = _this$props.delay,
          icon = _this$props.icon,
          id = _this$props.id,
          onClick = _this$props.onClick,
          onKeyDown = _this$props.onKeyDown,
          open = _this$props.open,
          tooltipTitle = _this$props.tooltipTitle,
          TooltipClasses = _this$props.TooltipClasses,
          tooltipPlacement = _this$props.tooltipPlacement,
          tooltipOpen = _this$props.tooltipOpen,
          other = (0, _objectWithoutProperties2.default)(_this$props, ["ButtonProps", "classes", "className", "delay", "icon", "id", "onClick", "onKeyDown", "open", "tooltipTitle", "TooltipClasses", "tooltipPlacement", "tooltipOpen"]);
      var clickProps = {
        onClick: onClick
      };

      if (typeof document !== 'undefined' && 'ontouchstart' in document.documentElement) {
        var startTime;

        clickProps.onTouchStart = function () {
          startTime = new Date();
        };

        clickProps.onTouchEnd = function (event) {
          // only perform action if the touch is a tap, i.e. not long press
          if (new Date() - startTime < 500) {
            onClick();
          }

          event.preventDefault();
          event.stopPropagation();
        };
      }

      clickProps.style = {
        transitionDelay: "".concat(delay, "ms")
      };

      if (ButtonProps.style) {
        ButtonProps.style.transitionDelay = "".concat(delay, "ms");
      }

      var actionButton = _react.default.createElement(_Fab.default, (0, _extends2.default)({
        size: "small",
        className: (0, _classnames.default)(className, classes.button, classes.actionButton, !open && classes.buttonClosed),
        style: {
          transitionDelay: "".concat(delay, "ms")
        },
        tabIndex: -1,
        role: "menuitem",
        onKeyDown: onKeyDown
      }, ButtonProps, clickProps), icon);

      if (tooltipOpen) {
        return _react.default.createElement("span", {
          className: classes.tooltipOpenContainer
        }, _react.default.createElement(_Paper.default, (0, _extends2.default)({
          className: (0, _classnames.default)(classes.textLabel, classes.button, !open && classes.buttonClosed)
        }, clickProps), _react.default.createElement(_Typography.default, {
          color: "inherit"
        }, tooltipTitle)), actionButton);
      }

      return _react.default.createElement(_Tooltip.default, (0, _extends2.default)({
        id: id,
        title: tooltipTitle,
        placement: tooltipPlacement,
        onClose: this.handleTooltipClose,
        onOpen: this.handleTooltipOpen,
        open: open && this.state.tooltipOpen,
        classes: TooltipClasses
      }, other), actionButton);
    }
  }]);
  return SpeedDialAction;
}(_react.default.Component);

process.env.NODE_ENV !== "production" ? SpeedDialAction.propTypes = {
  /**
   * Properties applied to the [`Button`](/api/button/) component.
   */
  ButtonProps: _propTypes.default.object,

  /**
   * Override or extend the styles applied to the component.
   * See [CSS API](#css-api) below for more details.
   */
  classes: _propTypes.default.object.isRequired,

  /**
   * @ignore
   */
  className: _propTypes.default.string,

  /**
   * Adds a transition delay, to allow a series of SpeedDialActions to be animated.
   */
  delay: _propTypes.default.number,

  /**
   * The Icon to display in the SpeedDial Floating Action Button.
   */
  icon: _propTypes.default.node.isRequired,

  /**
   * @ignore
   */
  id: _propTypes.default.string,

  /**
   * @ignore
   */
  onClick: _propTypes.default.func,

  /**
   * @ignore
   */
  onKeyDown: _propTypes.default.func,

  /**
   * @ignore
   */
  open: _propTypes.default.bool,

  /**
   * Classes applied to the [`Tooltip`](/api/tooltip/) element.
   */
  TooltipClasses: _propTypes.default.object,

  /**
   * Make the tooltip always visible when the SpeedDial is open.
   */
  tooltipOpen: _propTypes.default.bool,

  /**
   * Placement of the tooltip.
   */
  tooltipPlacement: _propTypes.default.oneOf(['bottom-end', 'bottom-start', 'bottom', 'left-end', 'left-start', 'left', 'right-end', 'right-start', 'right', 'top-end', 'top-start', 'top']),

  /**
   * Label to display in the tooltip.
   */
  tooltipTitle: _propTypes.default.node.isRequired
} : void 0;
SpeedDialAction.defaultProps = {
  delay: 0,
  open: false,
  tooltipPlacement: 'left',
  tooltipOpen: false
};

var _default = (0, _styles.withStyles)(styles, {
  name: 'MuiSpeedDialAction'
})(SpeedDialAction);

exports.default = _default;